/*
 * network.java
 *
 * Created on 6. Juni 2007, 19:26
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package network;

import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Vector;
import softwareprojekt.Form;
import softwareprojekt.Lecture;
import softwareprojekt.User;
import softwareprojekt.Connection;
/**
 *
 * @author PMV
 */
public class Network extends Connection{
    private Socket socket = null;
    private ReceivedData receive = null;
    private SendData send = null;
    
    //erstellt ein neues Objekt der Klasse
    public Network() {
        initCon();
    }
    //-------------------------------------
    
    public boolean checkReceive(){
        if (this.receive.obj != null){
            char result = ((String) this.receive.obj).charAt(0);
            if (((String) this.receive.obj).charAt(0) == this.send.typ){
                return true;
            }
        }
        return false;
    }
    
    /*
     * Initialisiert die Verbindung zum Server.
     * Jedes Netzwerk-Objekt kann nur eine Verbindung haben, wurde bereits
     * eine erfolgreiche Verbindung hergestellt gibt diese Methode
     * dennoch "true" zurck.
     */
    public boolean initCon() {
        if (this.isConnected()) {
            return true;
        }
        
        try {
            this.socket = new Socket("localhost", 80);
            this.receive = new ReceivedData(
                    new DataInputStream(socket.getInputStream()));
            this.send = new SendData(
                    new DataOutputStream(socket.getOutputStream()));
        } catch (UnknownHostException ex) {
            //ex.printStackTrace();
            System.out.println("Host nicht gefunden!");
            this.socket = null;
        } catch (IOException ex) {
            ex.printStackTrace();
            this.socket = null;
        }
        return this.isConnected();    

    }
    
    /** Testet das Netzwerk-Objekt auf eine vorhandene Verbindung */
    public boolean isConnected() {
        if (this.socket == null) {
            return false;
        } else if (this.socket.isConnected()) {
            return true;
        } else {
            this.socket = null;
             System.out.println("socket = null");
            return false;
        }
    }
    
    /** Versucht den bergebenen Benutzer ein zu loggen */
    public boolean Login(String userID, String password, char userTyp) {
        if (user == null){
            if (this.isConnected()){
                
                this.send.makeLogin(userID, password, userTyp);
                if (this.send.send()) {
                    if (this.receive.receive()) {
                        if (this.receive.getObject() instanceof User){
                            this.user = (User) this.receive.getObject();
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
    
    /** Loggt den vorher eingeloggten Benutzer wieder aus */
    public void Logout() {
        if (this.user != null){
            if (this.isConnected()){
                this.send.makeLogout();
                if (this.send.send()) {
                    if (!this.receive.receive()) {
                        //ERROR!!
                    }
                }
            }
            this.user = null;
        }
    }
    
    /** Verbindungsabbau der vorher mittels initCon() erstellten Verbindung .*/
    public void disCon() {
        if (this.isConnected()){
            try {
                this.socket.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        this.socket = null;
        this.user = null;
    }
    
    /** ndern des Passwortes des eingeloggten Benutzers auf ein neues. */
    public boolean changePassword(String oldPassword, String newPassword){
        if (this.user != null){
            if (this.isConnected()){
                this.send.makeChangePwd(oldPassword, newPassword);
                if (this.send.send()){
                    if (this.receive.receive()){
                        if (this.checkReceive()){
                            return true;
                        }
                    }
                }
                
            }
        }
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean deleteUser(User user) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean deleteForm(Form form) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean deleteLecture(Lecture lecture) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean createUser(User user) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean createForm(Form form) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean createLecture(Lecture lecture) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean updateLecture(Lecture lecture) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean updateForm(Form form) {
        return false;
    }
    
    /** In dieser Schnittstelle nicht bentigt. */
    public boolean updateUser(User user) {
        return false;
    }
    
    public String[] getUserList() {
        return null;
    }
    
    public String[] getFormList() {
        return null;
    }
    
    public String[] getLectureList() {
        return null;
    }
    
    public String[] getFormList(String[] lectures) {
        return null;
    }
    
    public String[] getLectureList(User prof) {
        return null;
    }
    
    public User getUser(String id) {
        return null;
    }
    
    public Form getForm(String id) {
        return null;
    }
    
    public Form getForm(String room, int time) {
        return null;
    }
    
    public Lecture getLecture(String shortName) {
        return null;
    }
    
    public boolean existFormForStudy(String room, int time) {
        return false;
    }
    
    public boolean existAnswerForStudy(String room, int time) {
        return false;
    }
    
    public boolean insertAnswerFromStudy(Form form){
        return false;
    }
    
    
    
}
