/*
 * receiveData.java
 *
 * Created on 9. Juni 2007, 19:25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package network;

import java.io.DataInputStream;
import java.io.IOException;
import softwareprojekt.User;

/**
 *
 * @author PMV
 */
public class ReceivedData extends Data {
    //TimeOut in Millisekunden fr das warten auf Daten
    private static final long TIMEOUT = 3000;  
    
    DataInputStream reader = null;
    Object obj = null; //das empfangende Objekt
    
    public ReceivedData(DataInputStream reader) {
        this.reader = reader;
    }
    
    protected void reset() {
        super.reset();
        this.obj = null;
    }
    
    /** Liet die nchste Nachricht ein.
     * Konnte die Nachricht korrekt empfangen werden, wird true
     * zurck gegeben, andernfalls false.
     */
    public boolean receive() {
        byte [] array = null;
        
        //alle Attribute resetten
        this.reset();
        
        //Empfangen der Nachricht gem Protokoll
        try {
            this.key = reader.readInt();
            this.length = reader.readInt();
            this.typ = (char) reader.readByte();
            array = new byte [this.length];
            if (!this.waitForAnswer(this.length)) {
                //ERROR!!!
                obj = "TimeOut!";
                return false;
            }
            reader.read(array);
        } catch (IOException ex) {
            ex.printStackTrace();
            obj = ex.getMessage();
            //ERROR!!!
            return false;
        }
        

        data = new ByteArray(array); 
        if (!this.validKey()){
            //ERROR!!
            return false;
        }
        
        switch (typ){
            case 's': //Fragebogen ohne Stimmenanzahl
                obj = this.data.toFormSimple();
                return true;
            case 'f': //Fragebogen mit Stimmenanzahl
                obj = this.data.toForm();
                return true;
            case 'u': //Benutzer
                obj = this.data.toUser();
                return true;
            case 'l': //Vorlesung
                obj = this.data.toLecture();
                return true;
                
            //Statusmeldungen
            case 'O': //OK
                //Nachrichteninhalt ist die vorheriege Aktion!
                obj = this.data.toString();
                return true;

            case 'E': //Fehler
                obj = this.data.toString();
                return false;
            
            //ungefragte Nachrichten an den Server:
            case 'o': //Logout
            case 'i': //Login
            case 'p': //Passwort ndern
            case 'D': //ID Liste senden
            case 'U': //User senden
            case 'F': //Fragebogen senden
            case 'L': //Vorlesung senden
                obj = String.valueOf(typ) + this.data.toString();
                return true;
                
        }
        return false;
    }       
    
    /** Gibt das zuletzt erstellte Objekt zurck */
    public Object getObject() {
        return this.obj;
    }
    
    /** Wartet, bis die angegebene Bytemenge im Puffer steht 
     * Wurde erfolgreich gewartet, wird true zurck gegeben.
     * Kommt es hingegen zu einem Timeout wird false zurck gegeben.
     */
    public boolean waitForAnswer(int dataLength){
        try {
            long timer = System.currentTimeMillis();
            while (this.reader.available() < dataLength){
                
                try {
                    java.lang.Thread.sleep(1); //kurze Pause                
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                } 
                
                if (timer + TIMEOUT <= System.currentTimeMillis()){
                    //System.out.println(dataLength + "/" + this.reader.available());
                    return false;
                }
            }
            return true;
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        return false;
    }
    
    //prft den empfangenden Schlssel
    private boolean validKey(){
        if (this.data.getKey() == key){
            return true;
        } 
        return false;
    }
}
