/*
 * DB.java
 *
 * Created on 30. Mai 2007, 22:18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package softwareprojekt;

import java.io.CharArrayReader;

/**
 *
 * @author PMV
 */
public abstract class Connection {
    protected User user = null; //enthlt den Datensatz des eingeloggten Users
    private String lastError = ""; //enthlt die Fehlermeldung des letzten Fehlers

    //allgemeine Methoden 
        //auslesen wichtiger Daten aus einer Datei und verbinden
        public abstract boolean initCon(); 
        //gibt zurck, ob bereits eine Verbindung existiert
        public abstract boolean isConnected();  
        //Einloggen eines Benutzers (userTyp = erwarteter Typ)
        public abstract boolean Login(String userID, String password, char userTyp);
        public abstract void Logout();
        public abstract void disCon(); //Verbindung kappen und interne Referenz lschen 

        public String getLastError() { //gibt die letzte Fehlermeldung zurck
            return lastError;
        }
        
        //gibt das User-Objekt des eingeloggten Benutzers zurck
        public User getLoggedUser(){
            return this.user;
        }
    //----

    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    // !!!! folgende Methoden sind erst nach  !!!!
    // !!!! einem erfolgreichen Login mglich !!!!
    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
    //eigenes Passwort ndern (des eingeloggten Benutzers)
    public abstract boolean changePassword(String oldPassword, 
                                           String newPassword);
    //----
    
    //Methoden fr den Adminclient zum verwalten der Daten (Typ 'A')
    public abstract boolean deleteUser(User user);
    public abstract boolean deleteForm(Form form);
    public abstract boolean deleteLecture(Lecture lecture);
    public abstract boolean createUser(User user);
    public abstract boolean createForm(Form form);
    public abstract boolean createLecture(Lecture lecture);
    public abstract  boolean updateLecture(Lecture lecture);
    public abstract boolean updateForm(Form form);
    public abstract boolean updateUser(User user);
    //----
    
    //abfragen der vorhandenen Eintrge (Rckgabe der IDs) 
    public abstract String[] getUserList();     //darf nur Typ 'A' nutzen
    public abstract String[] getFormList();     //darf nur Typ 'A' nutzen
    public abstract String[] getLectureList();  //darf Typ 'S' nicht nutzen
    //----
    
    //auslesen der Objekte
    public abstract User getUser(String id); //darf nur Typ 'A'
    public abstract Form getForm(String id); //darf nur Typ 'A' und 'D'
    public abstract Form getForm(String room, int time); //darf nur Typ 'S'
    public abstract Lecture getLecture(String shortName); //darf nur Typ 'A' und 'D'
    //----
    
    //spezielle Abfragen fr den Studentenclient (Typ 'S')
    public abstract boolean existFormForStudy(String room, int time);
    public abstract boolean existAnswerForStudy(String room, int time);
    public abstract boolean insertAnswerFromStudy(Form form);
    //----
    
}
